#include <float.h>
#include "Real.h"

/** A usefull constant, used as the smallest positive real. 
* This value is currenly set to 1e-8.
*/
const real EPSILON = real(1e-8);

/** The mathematical constant PI. */
const real PI = real(3.14159265359);

/** The mathematical constant 2*PI. */
const real TWO_PI = real(2*PI);

/** Maximum value */
const real REAL_MAX = FLT_MAX;

/** Minimum value */
const real REAL_MIN = FLT_MIN;