
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NUMBER	257
#define	STRING_LITERAL	258
#define	IDENTIFIER	259
#define	K_TRUE	260
#define	K_FALSE	261
#define	K_DEF	262
#define	K_USE	263
#define	K_PROTO	264
#define	K_EXTERNPROTO	265
#define	K_TO	266
#define	K_ROUTE	267
#define	K_IS	268
#define	K_NULL	269
#define	K_EVENTIN	270
#define	K_EVENTOUT	271
#define	K_EXPOSEDFIELD	272
#define	K_FIELD	273
#define	K_SCRIPT	274
#define	MFColor	275
#define	MFFloat	276
#define	MFInt32	277
#define	MFNode	278
#define	MFRotation	279
#define	MFString	280
#define	MFTime	281
#define	MFVec2f	282
#define	MFVec3f	283
#define	SFBool	284
#define	SFColor	285
#define	SFFloat	286
#define	SFImage	287
#define	SFInt32	288
#define	SFNode	289
#define	SFRotation	290
#define	SFString	291
#define	SFTime	292
#define	SFVec2f	293
#define	SFVec3f	294
#define	LS	295
#define	RS	296
#define	AT	297
#define	AND	298
#define	OR	299
#define	LE	300
#define	GE	301
#define	EQ	302
#define	NE	303



#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

#include "wrlFlexLexer.h"
#include "element.h"
#include "attribute.h"
#include "myString.h"

Element *vrmlRoot;	/* adi: gets root element of last parsed vrml file */

extern int yylex();
extern void yyerror(char * s);

inline Element * newRouteElement(const myString * fromNodeValue,
                                 const myString * fromFieldValue,
                                 const myString * toNodeValue,
                                 const myString * toFieldValue);
 
inline Element * newFieldElement(const char * hint,
                                 const myString * name,
                                 const myString * type = 0,
                                 const myString * value = 0);

inline Element * newIsElement(const myString * name, const myString * is);
 

typedef union {
    const char * tmpText;
    myString * text;
    Element * element;
    Attribute * attribute;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		171
#define	YYFLAG		-32768
#define	YYNTBASE	56

#define YYTRANSLATE(x) ((unsigned)(x) <= 303 ? yytranslate[x] : 94)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    55,     2,    54,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    50,     2,    51,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    52,     2,    53,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     5,     8,    10,    12,    14,    16,    20,
    23,    25,    27,    36,    37,    40,    44,    48,    53,    58,
    60,    65,    70,    77,    78,    81,    85,    89,    93,    97,
   106,   108,   110,   113,   117,   122,   127,   128,   132,   138,
   142,   147,   153,   158,   161,   164,   166,   169,   171,   174,
   176,   178,   180,   186,   192,   198,   201,   203,   205,   207,
   209,   211,   213,   215,   217,   219,   221,   223,   225,   227,
   229,   231,   233,   235,   237,   239,   241,   243,   245,   247,
   249,   251,   253,   255,   257,   259,   261,   263,   265,   267,
   269,   271,   273,   275,   278,   280,   283,   287,   289,   292,
   295,   299,   301
};

static const short yyrhs[] = {    57,
     0,    58,     0,     0,    58,    59,     0,    60,     0,    61,
     0,    69,     0,    72,     0,     8,    77,    72,     0,     9,
    77,     0,    62,     0,    66,     0,    10,    78,    50,    63,
    51,    52,    58,    53,     0,     0,    63,    65,     0,    16,
    83,    80,     0,    17,    83,    81,     0,    19,    83,    79,
    84,     0,    19,    83,    79,    87,     0,    64,     0,    18,
    83,    79,    84,     0,    18,    83,    79,    87,     0,    11,
    78,    50,    67,    51,    70,     0,     0,    67,    68,     0,
    16,    83,    80,     0,    17,    83,    81,     0,    19,    83,
    79,     0,    18,    83,    79,     0,    13,    77,    54,    81,
    12,    77,    54,    80,     0,    71,     0,    88,     0,    50,
    51,     0,    50,    90,    51,     0,    78,    52,    73,    53,
     0,    20,    52,    74,    53,     0,     0,    73,    79,    85,
     0,    73,    79,    50,    93,    51,     0,    73,    79,    87,
     0,    73,    79,    50,    51,     0,    73,    79,    50,    91,
    51,     0,    73,    79,    14,    79,     0,    73,    69,     0,
    73,    61,     0,    75,     0,    74,    75,     0,    76,     0,
    74,    76,     0,    64,     0,    69,     0,    61,     0,    16,
    83,    80,    14,    80,     0,    17,    83,    81,    14,    81,
     0,    19,    83,    79,    14,    79,     0,    79,    84,     0,
    82,     0,    82,     0,    82,     0,    82,     0,    82,     0,
     5,     0,    21,     0,    22,     0,    23,     0,    24,     0,
    25,     0,    26,     0,    27,     0,    28,     0,    29,     0,
    30,     0,    31,     0,    32,     0,    33,     0,    34,     0,
    35,     0,    36,     0,    37,     0,    38,     0,    39,     0,
    40,     0,    85,     0,    92,     0,    89,     0,    86,     0,
    88,     0,     6,     0,     7,     0,    60,     0,    15,     0,
     4,     0,     3,     0,    89,     3,     0,     4,     0,    90,
     4,     0,    90,    55,     4,     0,    60,     0,    91,    60,
     0,    50,    51,     0,    50,    93,    51,     0,    89,     0,
    90,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   112,   114,   116,   117,   120,   121,   122,   125,   126,   127,
   130,   131,   134,   137,   138,   141,   142,   143,   144,   147,
   148,   149,   152,   155,   156,   159,   160,   161,   162,   165,
   168,   171,   172,   173,   178,   179,   182,   183,   184,   185,
   186,   187,   188,   191,   192,   196,   197,   198,   199,   202,
   203,   204,   205,   206,   207,   214,   217,   220,   223,   226,
   229,   232,   247,   248,   249,   250,   251,   252,   253,   254,
   255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
   265,   266,   270,   271,   274,   275,   276,   279,   280,   283,
   284,   287,   290,   291,   294,   295,   296,   299,   300,   303,
   304,   307,   308
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NUMBER",
"STRING_LITERAL","IDENTIFIER","K_TRUE","K_FALSE","K_DEF","K_USE","K_PROTO","K_EXTERNPROTO",
"K_TO","K_ROUTE","K_IS","K_NULL","K_EVENTIN","K_EVENTOUT","K_EXPOSEDFIELD","K_FIELD",
"K_SCRIPT","MFColor","MFFloat","MFInt32","MFNode","MFRotation","MFString","MFTime",
"MFVec2f","MFVec3f","SFBool","SFColor","SFFloat","SFImage","SFInt32","SFNode",
"SFRotation","SFString","SFTime","SFVec2f","SFVec3f","LS","RS","AT","AND","OR",
"LE","GE","EQ","NE","'['","']'","'{'","'}'","'.'","','","Start","vrmlScene",
"statements","statement","nodeStatement","protoStatement","proto","interfaceDeclarations",
"restrictedInterfaceDeclaration","interfaceDeclaration","externproto","externInterfaceDeclarations",
"externInterfaceDeclaration","routeStatement","URLList","mfstringValue","node",
"nodeBody","scriptBody","scriptBodyElement","scriptBodyAttribute","nodeNameId",
"nodeTypeId","fieldId","eventInId","eventOutId","Id","fieldType","fieldValue",
"sfValue","sfboolValue","sfnodeValue","sfstringValue","sfint32Values","sfstringValues",
"nodeStatements","mfValue","sfValues", NULL
};
#endif

static const short yyr1[] = {     0,
    56,    57,    58,    58,    59,    59,    59,    60,    60,    60,
    61,    61,    62,    63,    63,    64,    64,    64,    64,    65,
    65,    65,    66,    67,    67,    68,    68,    68,    68,    69,
    70,    71,    71,    71,    72,    72,    73,    73,    73,    73,
    73,    73,    73,    73,    73,    74,    74,    74,    74,    75,
    75,    75,    75,    75,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    83,    83,    83,    83,    83,    83,    83,
    83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
    83,    83,    84,    84,    85,    85,    85,    86,    86,    87,
    87,    88,    89,    89,    90,    90,    90,    91,    91,    92,
    92,    93,    93
};

static const short yyr2[] = {     0,
     1,     1,     0,     2,     1,     1,     1,     1,     3,     2,
     1,     1,     8,     0,     2,     3,     3,     4,     4,     1,
     4,     4,     6,     0,     2,     3,     3,     3,     3,     8,
     1,     1,     2,     3,     4,     4,     0,     3,     5,     3,
     4,     5,     4,     2,     2,     1,     2,     1,     2,     1,
     1,     1,     5,     5,     5,     2,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     2,     1,     2,     3,     1,     2,     2,
     3,     1,     1
};

static const short yydefact[] = {     3,
     1,     2,    62,     0,     0,     0,     0,     0,     0,     4,
     5,     6,    11,    12,     7,     8,     0,    58,     0,    57,
    10,     0,     0,     0,     0,    37,     9,    14,    24,     0,
     0,     0,     0,    52,    50,    51,     0,    46,    48,     0,
    59,     0,     0,     0,     0,    61,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,     0,     0,     0,    36,
    47,    49,    93,    92,    88,    89,     0,    56,    83,    86,
    87,    85,    84,    35,    45,    44,     0,     0,     0,     0,
     0,     0,    20,    15,     0,     0,     0,     0,     0,    25,
     0,    16,    60,    17,     0,    95,   100,   102,   103,     0,
    94,     0,    91,     0,    90,    38,    40,     0,     0,     0,
     0,     3,     0,     0,     0,     0,     0,    23,    31,    32,
     0,     0,     0,     0,    18,    19,    96,     0,   101,    43,
    41,    98,     0,     0,    16,    17,     0,     0,     0,    26,
    27,    29,    28,    33,     0,     0,    53,    54,    55,    97,
    42,    99,    39,    21,    22,    13,    34,    30,     0,     0,
     0
};

static const short yydefgoto[] = {   169,
     1,     2,    10,   115,    12,    13,    43,    35,    94,    14,
    44,   100,    15,   128,   129,    16,    42,    37,    38,    39,
    19,    17,    40,   102,    45,    18,    67,   135,    79,    80,
   136,    81,    82,   109,   143,    83,   110
};

static const short yypact[] = {-32768,
-32768,   195,-32768,    11,    11,    11,    11,    11,   -25,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -20,-32768,     8,-32768,
-32768,    -9,     1,     2,   244,-32768,-32768,-32768,-32768,    11,
   208,   208,   208,-32768,-32768,-32768,    26,-32768,-32768,   100,
-32768,     9,    94,   145,    34,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    11,    11,    11,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    21,-32768,-32768,-32768,
-32768,    52,-32768,-32768,-32768,-32768,   129,   208,   208,   208,
   208,    41,-32768,-32768,   208,   208,   208,   208,    49,-32768,
    11,    82,-32768,    88,   151,-32768,-32768,    52,     5,    43,
-32768,    11,-32768,    80,-32768,-32768,-32768,    11,    11,    11,
    11,-32768,    11,    11,    11,    11,     6,-32768,-32768,-32768,
    51,    11,    11,    11,-32768,-32768,-32768,   119,-32768,-32768,
-32768,-32768,   177,    73,-32768,-32768,   169,   169,    39,-32768,
-32768,-32768,-32768,-32768,     3,    11,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   125,   126,
-32768
};

static const short yypgoto[] = {-32768,
-32768,    17,-32768,     4,    -8,-32768,-32768,    97,-32768,-32768,
-32768,-32768,    -2,-32768,-32768,   108,-32768,-32768,   104,   105,
     0,    84,   -39,    70,   -53,    -4,   -21,   -38,    59,-32768,
   -69,    68,   -16,    24,-32768,-32768,    54
};


#define	YYLAST		263


static const short yytable[] = {    20,
    20,    78,    87,    20,    21,    11,   137,    24,   137,   106,
    68,    69,     3,     3,   104,     3,    34,   117,     6,     7,
    41,     8,    36,    73,   106,    46,    25,     9,    34,   105,
     3,    26,    41,    85,    36,     6,     7,    41,     8,    86,
    28,    31,    32,     3,    33,   101,     4,     5,     6,     7,
    29,     8,    74,   167,   111,    30,   154,   138,     9,   138,
   108,    84,   103,    46,    41,   146,   118,   119,   120,   121,
   151,   107,   140,   123,   124,   125,   126,   165,    70,   158,
   147,   148,    73,   106,     3,   152,   153,     4,     5,    22,
    23,   166,   122,   139,   159,   132,    20,   108,   127,     9,
   131,   133,    73,    74,   156,    75,    76,    41,   164,    88,
    89,    90,    91,   103,    46,    41,    41,   142,   103,    46,
    41,    41,   160,   163,   170,   171,    27,   103,    46,    41,
   141,    73,    74,     3,    75,    76,     4,     5,   149,    93,
    71,    72,   112,   113,    92,   116,   162,     0,     9,    77,
   155,   103,    11,    73,    74,     3,    75,    76,     4,     5,
    95,    96,    97,    98,   134,   113,   130,   144,     0,     0,
     9,    73,    74,     3,    75,    76,     4,     5,   114,     0,
     0,     3,     0,   113,     4,     5,     0,   145,     9,     0,
     0,     0,   150,     0,     0,    99,     9,     0,     0,     3,
    77,   157,     4,     5,     6,     7,     0,     8,     0,     0,
     0,     0,     0,     0,     9,     0,     0,     0,    77,     0,
     0,     0,     0,     0,     0,   168,     0,   161,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,     3,     0,
     0,     0,     0,     6,     7,     0,     8,     0,     0,    31,
    32,     0,    33
};

static const short yycheck[] = {     4,
     5,    40,    42,     8,     5,     2,     4,     8,     4,     4,
    32,    33,     5,     5,    68,     5,    25,    87,    10,    11,
    25,    13,    25,     3,     4,    30,    52,    20,    37,    69,
     5,    52,    37,    42,    37,    10,    11,    42,    13,    42,
    50,    16,    17,     5,    19,    12,     8,     9,    10,    11,
    50,    13,     4,    51,     3,    54,    51,    55,    20,    55,
    77,    53,    67,    68,    69,   119,    88,    89,    90,    91,
   124,    51,   112,    95,    96,    97,    98,   147,    53,   133,
   120,   121,     3,     4,     5,   125,   126,     8,     9,     6,
     7,    53,    52,    51,   134,    14,   101,   114,    50,    20,
   101,    14,     3,     4,    54,     6,     7,   112,   147,    16,
    17,    18,    19,   118,   119,   120,   121,   114,   123,   124,
   125,   126,     4,    51,     0,     0,    19,   132,   133,   134,
    51,     3,     4,     5,     6,     7,     8,     9,   122,    43,
    37,    37,    14,    15,    51,    87,   143,    -1,    20,    50,
   127,   156,   149,     3,     4,     5,     6,     7,     8,     9,
    16,    17,    18,    19,    14,    15,    99,   114,    -1,    -1,
    20,     3,     4,     5,     6,     7,     8,     9,    50,    -1,
    -1,     5,    -1,    15,     8,     9,    -1,   118,    20,    -1,
    -1,    -1,   123,    -1,    -1,    51,    20,    -1,    -1,     5,
    50,   132,     8,     9,    10,    11,    -1,    13,    -1,    -1,
    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    50,    -1,
    -1,    -1,    -1,    -1,    -1,   156,    -1,    51,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,     5,    -1,
    -1,    -1,    -1,    10,    11,    -1,    13,    -1,    -1,    16,
    17,    -1,    19
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
{ yyvsp[0].element->exportXml(); vrmlRoot = yyvsp[0].element; ;
    break;}
case 2:
{ yyval.element = new Element("X3D"); yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 3:
{ yyval.element = new Element("Scene"); ;
    break;}
case 4:
{ yyval.element = yyvsp[-1].element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 5:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 6:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 7:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 8:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 9:
{ yyval.element = yyvsp[0].element; yyval.element->addAttribute(new Attribute("DEF", yyvsp[-1].text, false), false); ;
    break;}
case 10:
{ yyval.element = new Element("USE"); yyval.element->addAttribute(new Attribute("name", yyvsp[0].text, false), false); ;
    break;}
case 11:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 12:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 13:
{ yyval.element = yyvsp[-4].element; yyval.element->set("ProtoDeclare"); yyval.element->addAttribute(new Attribute("name", yyvsp[-6].text, false), false); yyval.element->merge(yyvsp[-1].element); delete yyvsp[-1].element; ;
    break;}
case 14:
{ yyval.element = new Element; ;
    break;}
case 15:
{ yyval.element = yyvsp[-1].element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 16:
{ yyval.element = newFieldElement("eventIn", yyvsp[0].text, yyvsp[-1].text); ;
    break;}
case 17:
{ yyval.element = newFieldElement("eventOut", yyvsp[0].text, yyvsp[-1].text); ;
    break;}
case 18:
{ yyval.element = newFieldElement("field", yyvsp[-1].text, yyvsp[-2].text, yyvsp[0].text); ;
    break;}
case 19:
{ yyval.element = newFieldElement("field", yyvsp[-1].text, yyvsp[-2].text, new myString("0")); ;
    break;}
case 20:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 21:
{ yyval.element = newFieldElement("exposedField", yyvsp[-1].text, yyvsp[-2].text, yyvsp[0].text); ;
    break;}
case 22:
{ yyval.element = newFieldElement("field", yyvsp[-1].text, yyvsp[-2].text, new myString("0")); ;
    break;}
case 23:
{ yyval.element = yyvsp[-2].element; yyval.element->set("ExternProtoDeclare"); yyval.element->addAttribute(new Attribute("name", yyvsp[-4].text, false), false); yyval.element->addAttribute(new Attribute("url", yyvsp[0].text)); ;
    break;}
case 24:
{ yyval.element = new Element; ;
    break;}
case 25:
{ yyval.element = yyvsp[-1].element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 26:
{ yyval.element = newFieldElement("eventIn", yyvsp[0].text, yyvsp[-1].text); ;
    break;}
case 27:
{ yyval.element = newFieldElement("eventOut", yyvsp[0].text, yyvsp[-1].text); ;
    break;}
case 28:
{ yyval.element = newFieldElement("field", yyvsp[0].text, yyvsp[-1].text); ;
    break;}
case 29:
{ yyval.element = newFieldElement("exposedField", yyvsp[0].text, yyvsp[-1].text); ;
    break;}
case 30:
{ yyval.element = newRouteElement(yyvsp[-6].text, yyvsp[-4].text, yyvsp[-2].text, yyvsp[0].text); ;
    break;}
case 31:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 32:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 33:
{ yyval.text = new myString; ;
    break;}
case 34:
{ yyval.text = yyvsp[-1].text; ;
    break;}
case 35:
{ yyval.element = yyvsp[-1].element; yyval.element->set(yyvsp[-3].text); ;
    break;}
case 36:
{ yyval.element = yyvsp[-1].element; yyval.element->set("Script"); ;
    break;}
case 37:
{ yyval.element = new Element; ;
    break;}
case 38:
{ yyval.element = yyvsp[-2].element; yyval.element->addAttribute(new Attribute(yyvsp[-1].text,yyvsp[0].text)); ;
    break;}
case 39:
{ yyval.element = yyvsp[-4].element; yyval.element->addAttribute(new Attribute(yyvsp[-3].text,yyvsp[-1].text)); ;
    break;}
case 40:
{ yyval.element = yyvsp[-2].element; Element * elem = new Element(yyvsp[-1].text); elem->addElement(yyvsp[0].element); yyval.element->addElement(elem); ;
    break;}
case 41:
{ yyval.element = yyvsp[-3].element; yyval.element->addElement(new Element(yyvsp[-2].text)); ;
    break;}
case 42:
{ yyval.element = yyvsp[-4].element; yyvsp[-1].element->set(yyvsp[-3].text); yyval.element->addElement(yyvsp[-1].element); ;
    break;}
case 43:
{ yyval.element = yyvsp[-3].element; yyval.element->addElement(newIsElement(yyvsp[-2].text, yyvsp[0].text)); ;
    break;}
case 44:
{ yyval.element = yyvsp[-1].element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 45:
{ yyval.element = yyvsp[-1].element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 46:
{ yyval.element = new Element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 47:
{ yyval.element = yyvsp[-1].element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 48:
{ yyval.element = new Element; yyval.element->addAttribute(yyvsp[0].attribute); ;
    break;}
case 49:
{ yyval.element = yyvsp[-1].element; yyval.element->addAttribute(yyvsp[0].attribute); ;
    break;}
case 50:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 51:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 52:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 53:
{ yyval.element = newFieldElement("eventIn", yyvsp[-2].text, yyvsp[-3].text); ;
    break;}
case 54:
{ yyval.element = newFieldElement("eventOut", yyvsp[-2].text, yyvsp[-3].text); ;
    break;}
case 55:
{ yyval.element = newFieldElement("field", yyvsp[-2].text, yyvsp[-3].text); ;
    break;}
case 56:
{ yyval.attribute = new Attribute(yyvsp[-1].text, yyvsp[0].text); ;
    break;}
case 57:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 58:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 59:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 60:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 61:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 62:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 63:
{ yyval.text = new myString("Colors"); ;
    break;}
case 64:
{ yyval.text = new myString("Floats"); ;
    break;}
case 65:
{ yyval.text = new myString("Integers"); ;
    break;}
case 66:
{ yyval.text = new myString("Nodes"); ;
    break;}
case 67:
{ yyval.text = new myString("Rotations"); ;
    break;}
case 68:
{ yyval.text = new myString("Strings"); ;
    break;}
case 69:
{ yyval.text = new myString("Times"); ;
    break;}
case 70:
{ yyval.text = new myString("Vector2Floats"); ;
    break;}
case 71:
{ yyval.text = new myString("Vector2Floats"); ;
    break;}
case 72:
{ yyval.text = new myString("Boolean"); ;
    break;}
case 73:
{ yyval.text = new myString("Color"); ;
    break;}
case 74:
{ yyval.text = new myString("Float"); ;
    break;}
case 75:
{ yyval.text = new myString("Image"); ;
    break;}
case 76:
{ yyval.text = new myString("Integer"); ;
    break;}
case 77:
{ yyval.text = new myString("Node"); ;
    break;}
case 78:
{ yyval.text = new myString("Rotation"); ;
    break;}
case 79:
{ yyval.text = new myString("String"); ;
    break;}
case 80:
{ yyval.text = new myString("Time"); ;
    break;}
case 81:
{ yyval.text = new myString("Vector2Float"); ;
    break;}
case 82:
{ yyval.text = new myString("Vector3Float"); ;
    break;}
case 83:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 84:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 85:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 86:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 87:
{ yyval.text = yyvsp[0].text ;
    break;}
case 88:
{ yyval.text = new myString("TRUE"); ;
    break;}
case 89:
{ yyval.text = new myString("FALSE"); ;
    break;}
case 90:
{ yyval.element = yyvsp[0].element; ;
    break;}
case 91:
{ yyval.element = new Element("NULL"); ;
    break;}
case 92:
{ yyval.text = new myString(yyvsp[0].tmpText, true); ;
    break;}
case 93:
{ yyval.text = new myString(yyvsp[0].tmpText); ;
    break;}
case 94:
{ yyval.text = yyvsp[-1].text; yyval.text->append(yyvsp[0].tmpText); ;
    break;}
case 95:
{ yyval.text = new myString(yyvsp[0].tmpText, true); ;
    break;}
case 96:
{ yyval.text = yyvsp[-1].text; yyval.text->append(yyvsp[0].tmpText, true); ;
    break;}
case 97:
{ yyval.text = yyvsp[-2].text; yyval.text->append(yyvsp[0].tmpText, true); ;
    break;}
case 98:
{ yyval.element = new Element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 99:
{ yyval.element = yyvsp[-1].element; yyval.element->addElement(yyvsp[0].element); ;
    break;}
case 100:
{ yyval.text = new myString; ;
    break;}
case 101:
{ yyval.text = yyvsp[-1].text; ;
    break;}
case 102:
{ yyval.text = yyvsp[0].text; ;
    break;}
case 103:
{ yyval.text = yyvsp[0].text; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}


// global yyerror
void yyerror(char * message)
{
    wrlFlexLexer::instance()->yyerror(message, (int) yychar);
}

// global yylex
int yylex(void)
{
    return wrlFlexLexer::instance()->yylex();
}

inline Element * newRouteElement(const myString * fromNodeValue,
                                 const myString * fromFieldValue,
                                 const myString * toNodeValue,
                                 const myString * toFieldValue)
{
    Element * elem = new Element("ROUTE");

    Attribute * fromNode = new Attribute("fromNode", fromNodeValue);
    Attribute * fromField = new Attribute("fromField", fromFieldValue);
    Attribute * toNode = new Attribute("toNode", toNodeValue);
    Attribute * toField = new Attribute("toField", toFieldValue);

    elem->addAttribute(fromNode);
    elem->addAttribute(fromField);
    elem->addAttribute(toNode);
    elem->addAttribute(toField);

    return elem;
}

inline Element * newFieldElement(const char * hint,
                                 const myString * name,
                                 const myString * type,
                                 const myString * value)
{
    Element * elem = new Element("Field");

    Attribute * nameAttr = new Attribute("name", name, false);
    elem->addAttribute(nameAttr, false);

    if (type) {
        Attribute * typeAttr = new Attribute("type", type);
        elem->addAttribute(typeAttr);
    }
    
    if (value) {
        Attribute * valueAttr = new Attribute("value", value);
        elem->addAttribute(valueAttr);
    }
    
    Attribute * hintAttr = new Attribute("vrml97Hint", hint);
    elem->addAttribute(hintAttr);

    return elem;
}

Element * newIsElement(const myString * name, const myString * is)
{
    Element * elem = new Element("Field");
    elem->addAttribute(new Attribute("name", name, false), false);
    elem->addAttribute(new Attribute("IS", is));
    return elem;
}

